program ulamki;

uses crt;

type
  ulamek = record
    licznik, mianownik: integer;
  end;

var
  u1,u2,wynik: ulamek;
  znak,czy_koniec: char;
  stan_wejscia: boolean;

function nwd(a,b:integer):integer;
begin
  while a<>b do
    if a>b then a:=a-b else b:=b-a;
  nwd:=a;
end;

function czytaj_dane:boolean; {Zwraca TRUE gdy OK}
begin
  clrscr;
  write('Podaj licznik pierwszego uamka: ');
  readln(u1.licznik);
  write('Podaj mianownik pierwszego uamka: ');
  readln(u1.mianownik);
  if u1.mianownik=0 then begin
    writeln('Bd! Mianownik=0!');
    czytaj_dane:=false;
    exit;
  end;
  write('Podaj znak dziaania (+ - / *): ');
  repeat
    znak:=readkey;
  until znak in ['+','-','*','/'];
  writeln(znak);
  write('Podaj licznik drugiego uamka: ');
  readln(u2.licznik);
  write('Podaj mianownik drugiego uamka: ');
  readln(u2.mianownik);
  if u2.mianownik=0 then begin
    writeln('Bd! Mianownik=0!');
    czytaj_dane:=false;
    exit;
  end;
  with u1 do begin
    if (licznik<0) and (mianownik<0) then begin
      licznik:=abs(licznik);
      mianownik:=abs(mianownik);
    end;
    if (licznik>0) and (mianownik<0) then begin
      licznik:=-licznik;
      mianownik:=abs(mianownik);
    end;
  end;
  with u2 do begin
    if (licznik<0) and (mianownik<0) then begin
      licznik:=abs(licznik);
      mianownik:=abs(mianownik);
    end;
    if (licznik>0) and (mianownik<0) then begin
      licznik:=-licznik;
      mianownik:=abs(mianownik);
    end;
  end;
  czytaj_dane:=true;
end;

procedure wypisz_wynik;
var
  n: integer;
begin
  with wynik do begin
    if (licznik<0) and (mianownik<0) then begin
      licznik:=abs(licznik);
      mianownik:=abs(mianownik);
    end;
    if (licznik>0) and (mianownik<0) then begin
      licznik:=-licznik;
      mianownik:=abs(mianownik);
    end;
  end;
  if (wynik.licznik<>0) then n:=nwd(abs(wynik.licznik),wynik.mianownik);
  wynik.licznik:=wynik.licznik div n;
  wynik.mianownik:=wynik.mianownik div n;
  writeln(u1.licznik:6,'   ',u2.licznik:6,'   ',wynik.licznik:6);
  writeln('------ ',znak,' ------ = ------');
  writeln(u1.mianownik:6,'   ',u2.mianownik:6,'   ',wynik.mianownik:6);
end;

procedure pomnoz;
begin
  wynik.licznik:=u1.licznik*u2.licznik;
  wynik.mianownik:=u1.mianownik*u2.mianownik;
end;

procedure podziel;
begin
  if u2.licznik=0 then begin
    writeln('Bd! Prba dzielenia przez zero!');
    exit;
  end;
  wynik.licznik:=u1.licznik*u2.mianownik;
  wynik.mianownik:=u1.mianownik*u2.licznik;
end;

procedure dodaj;
var
  wsp_mian: integer;
begin
  if (u1.licznik=0) then begin
    wynik.licznik:=u2.licznik;
    wynik.mianownik:=u2.mianownik;
  end;
  if (u2.licznik=0) then begin
    wynik.licznik:=u1.licznik;
    wynik.mianownik:=u1.mianownik;
  end;
  begin {Do wsp. mian}
    wsp_mian:=u1.mianownik*u2.mianownik;
    u1.licznik:=(wsp_mian div u1.mianownik)*u1.licznik;
    u2.licznik:=(wsp_mian div u2.mianownik)*u2.licznik;
    u1.mianownik:=wsp_mian;
    u2.mianownik:=wsp_mian;
  end;
  wynik.licznik:=u1.licznik+u2.licznik;
  wynik.mianownik:=wsp_mian;
end;

procedure odejmij;
begin
  u2.licznik:=-u2.licznik;
  dodaj;
end;

begin
  repeat
    stan_wejscia:=czytaj_dane;
    if stan_wejscia then begin
      case znak of
        '+': dodaj;
        '-': odejmij;
        '*': pomnoz;
        '/': podziel;
      end;
    wypisz_wynik;
    end;
    writeln('Czy zakoczy program? (T/N)');
    czy_koniec:=upcase(readkey);
  until czy_koniec='T';
end.


